package com.urbancode.air.plugin.msmq;

import com.urbancode.air.CommandHelper;

public abstract class MSMQBase {
    //**************************************************************************
    // CLASS
    //**************************************************************************

    //**************************************************************************
    // INSTANCE
    //**************************************************************************
    
    File workDir;
    CommandHelper ch;
    String cscript = "cscript.exe";
    final String PLUGIN_HOME;
    final File pluginHome;     
    File vbsScriptDir;

    protected MSMQBase() {
        PLUGIN_HOME = System.getenv('PLUGIN_HOME');
        pluginHome = new File(PLUGIN_HOME);
        vbsScriptDir = new File(pluginHome, "vbs");
        if (new File("C:\\Windows\\SysWOW64").exists()) { 
            cscript = "C:\\Windows\\SysWOW64\\cscript.exe";
        }
        workDir = new File('.');
        ch = new CommandHelper(workDir);
        ch.ignoreExitValue(true);
    }

    protected int runVBSScript(String file, def arguments, String message) {
        return runVBSScript(file, arguments, message, null);
    }

    protected int runVBSScript(String file, def arguments, String message, Closure clos) {
        def finalFile = new File(vbsScriptDir, file);
        def finalArgs = [cscript, finalFile.absolutePath];
        arguments.each { arg ->
            finalArgs << arg;
        }

        return ch.runCommand(message, finalArgs, clos);
    }
}
